import 'package:flutter/material.dart';
import 'package:flutter_firebase_basic_tools/models/abei_user.dart';
import 'package:flutter_firebase_basic_tools/screens/login.dart';
import 'package:flutter_firebase_basic_tools/widgets/crop_widget.dart';
import 'custom_colors.dart';

class TestWidget extends StatefulWidget {
  @override
  _LoginComplaintViewState createState() => _LoginComplaintViewState();
}

class _LoginComplaintViewState extends State<TestWidget> {
  openHome(AbeiUser abeiUser) {}

  openForgotPassword() {}

  openRegister() {}

  CustomColors customColors = CustomColors();

  List<String> textList = [
    "Nº de Folio",
    "Contraseña",
    "Recordarme",
    "Ingresar",
    "¿Olvidaste tu contraseña?",
    "Denunciar",
  ];

  @override
  Widget build(BuildContext context) {
    return Login(
      //topbarBackgroundColor: customColors.aqua,
      topbarBackgroundColor: Colors.transparent,
      userInfoFormContainerColor1: Colors.white,
      userInfoFormContainerColor2: Colors.white,
      userInfoFormContainerColor3: Colors.white,
      rememberMeColor: customColors.lighterDarkBlue,
      loginButtonColor: customColors.lighterDarkBlue,
      forgotButtonColor: customColors.lighterDarkBlue,
      registerButtonColor: customColors.lighterDarkBlue,
      backgroundImagePath: "assets/images/emissor_logo_with_colors.png",
      languagePicker: false,
      openHome: openHome,
      openForgotPassword: openForgotPassword,
      openRegister: openRegister,
      cardColor: Colors.transparent,
      cardElevation: 0,
      customBackground: Container(
        color: Colors.white,
        width: MediaQuery.of(context).size.width,
        child: Align(
          alignment: Alignment.bottomLeft,
          child: CropWidget(
            child: Image.asset(
              "assets/images/emissor_e_logo.png",
              color: customColors.lighterDarkBlue.withOpacity(0.15),
              fit: BoxFit.cover,
            ),
            generalAlignment: Alignment.bottomLeft,
            verticalAlignment: Alignment.topCenter,
            horizontalAlignment: Alignment.centerRight,
            heightFactor: 0.8,
            widthFactor: 0.75,
          ),
        ),
      ),
      languagePickerItemsTextColor: customColors.aqua,
      textList: textList,
      loginButtonGradientColor: LinearGradient(
        begin: FractionalOffset.centerLeft,
        end: FractionalOffset.centerRight,
        colors: [
          Colors.red,
          Colors.pink,
        ],
      ),
    );
  }
}