import 'package:flutter/material.dart';

class CustomCard extends StatelessWidget {
  CustomCard({
    this.child,
    this.elevation,
    this.borderRadius,
    this.onPressed,
    this.color,
    this.linearGradient,
  });

  final Widget child;
  final double elevation;
  final double borderRadius;
  final Function onPressed;
  final Color color;
  final LinearGradient linearGradient;

  @override
  Widget build(BuildContext context) {
    return Container(
      decoration: BoxDecoration(
        color: color,
        gradient: linearGradient,
        borderRadius: BorderRadius.circular(
          borderRadius != null ? borderRadius : 3.0,
        ),
        boxShadow: [
          BoxShadow(
            color: Colors.grey,
            offset: Offset(0.0, 1.0),
            blurRadius: elevation != null ? elevation : 2.0,
          ),
        ],
      ),
      child: Material(
        color: Colors.transparent,
        child: InkWell(
          borderRadius: BorderRadius.circular(
            borderRadius != null ? borderRadius : 3.0,
          ),
          onTap: () {
            if (onPressed != null) {
              onPressed();
            }
            print("sdfsdf");
          },
          child: child,
        ),
      ),
    );
  }
}
