import 'package:flutter_firebase_basic_tools/widgets/characteristics_container_item.dart';
import 'package:flutter/material.dart';

class WhyUsContainer extends StatefulWidget {
  const WhyUsContainer({
    @required this.texts,
    this.backgroundImage,
    this.backgroundColor,
    @required this.characteristicIcon1,
    @required this.characteristicIcon2,
    @required this.characteristicIcon3,
    @required this.characteristicIconColor1,
    @required this.characteristicIconColor2,
    @required this.characteristicIconColor3,
    @required this.titleColor,
    @required this.subtitleColor,
  });

  final List<String> texts;
  final String backgroundImage;
  final Color backgroundColor;
  final IconData characteristicIcon1;
  final IconData characteristicIcon2;
  final IconData characteristicIcon3;
  final Color characteristicIconColor1;
  final Color characteristicIconColor2;
  final Color characteristicIconColor3;
  final Color titleColor;
  final Color subtitleColor;

  @override
  _WhyUsContainerState createState() => _WhyUsContainerState();
}

class _WhyUsContainerState extends State<WhyUsContainer> {
  @override
  Widget build(BuildContext context) {
    bool isPortrait =
        MediaQuery.of(context).size.width > MediaQuery.of(context).size.height
            ? false
            : true;

    return Container(
      decoration: BoxDecoration(
        image: widget.backgroundImage != null
            ? DecorationImage(
                fit: BoxFit.fitHeight,
                image: AssetImage(
                  widget.backgroundImage,
                ),
              )
            : null,
        color: widget.backgroundColor,
      ),
      height: isPortrait
          ? (MediaQuery.of(context).size.height * 3.2)
          : (MediaQuery.of(context).size.height),
      width: MediaQuery.of(context).size.width,
      child: FractionallySizedBox(
        widthFactor: isPortrait ? 1 : 0.8,
        child: Column(
          children: <Widget>[
            Spacer(flex: 1),
            Expanded(
              flex: isPortrait ? 3 : 1,
              child: FractionallySizedBox(
                widthFactor: 0.7,
                child: Text(
                  widget.texts[0],
                  textAlign: TextAlign.center,
                  style: TextStyle(
                    color: widget.titleColor,
                    fontSize: 40,
                    //fontWeight: FontWeight.bold,
                  ),
                ),
              ),
            ),
            Expanded(
              flex: isPortrait ? 2 : 1,
              child: FractionallySizedBox(
                widthFactor: 0.7,
                child: Text(
                  widget.texts[1],
                  textAlign: TextAlign.center,
                  style: TextStyle(
                    color: widget.subtitleColor,
                    fontSize: 18,
                  ),
                ),
              ),
            ),
            Expanded(
              flex: isPortrait ? 42 : 12,
              child: Flex(
                direction: isPortrait ? Axis.vertical : Axis.horizontal,
                children: <Widget>[
                  Expanded(
                    flex: isPortrait ? 5 : 1,
                    child: CharacteristicsContainerItem(
                      //title: widget.texts[2],
                      title: "American",
                      description: widget.texts[3],
                      icon: widget.characteristicIcon1,
                      color: Colors.white.withAlpha(0),
                      titleColor: widget.titleColor,
                      subtitleColor: widget.subtitleColor,
                      iconColor: widget.characteristicIconColor1,
                      sideIcon: false,
                      largeDescription: true,
                      alignToLeftDescription: true,
                    ),
                  ),
                  Expanded(
                    flex: isPortrait ? 5 : 1,
                    child: CharacteristicsContainerItem(
                      //title: widget.texts[4],
                      title: "Business",
                      description: widget.texts[5],
                      icon: widget.characteristicIcon2,
                      color: Colors.white.withAlpha(0),
                      titleColor: widget.titleColor,
                      subtitleColor: widget.subtitleColor,
                      iconColor: widget.characteristicIconColor2,
                      sideIcon: false,
                      largeDescription: true,
                      alignToLeftDescription: true,
                    ),
                  ),
                  Expanded(
                    flex: isPortrait ? 5 : 1,
                    child: CharacteristicsContainerItem(
                      //title: widget.texts[6],
                      title: "Excellence",
                      description: widget.texts[7],
                      icon: widget.characteristicIcon3,
                      color: Colors.white.withAlpha(0),
                      titleColor: widget.titleColor,
                      subtitleColor: widget.subtitleColor,
                      iconColor: widget.characteristicIconColor3,
                      sideIcon: false,
                      largeDescription: true,
                      alignToLeftDescription: true,
                    ),
                  ),
                ],
              ),
            ),
            Spacer(flex: 1),
          ],
        ),
      ),
    );
  }
}
